;;-----------------------------------------------------------------------------
;; The confidential and proprietary information contained in this file may
;; only be used by a person authorised under and to the extent permitted
;; by a subsisting licensing agreement from ARM Limited.
;;
;;   (C) COPYRIGHT 1994-2007,2010-2012,2019 by Arm Limited (or its affiliates).
;;       ALL RIGHTS RESERVED
;;
;; This entire notice must be reproduced on all copies of this file
;; and copies of this file may only be made by a person if such person is
;; permitted to do so under the terms of a subsisting license agreement
;; from ARM Limited.
;;-----------------------------------------------------------------------------

;==================================================================
; This code provides basic global enable for an Cortex-A cache
; and program flow prediction
; This code must be run from a privileged mode
;==================================================================

        AREA   CORTEXA_CACHE, CODE, READONLY      ; name this block of code
        EXPORT cache_init



cache_init        


;==================================================================
; Global Enable for Cortex-A Instruction and Data Caching
;==================================================================

        MRC     p15, 0, r0, c1, c0, 0       ; read CP15 register 1 into r0
        ORR     r0, r0, #(0x1  <<12)        ; enable I Cache        
        ORR     r0, r0, #(0x1  <<2)         ; enable D Cache
        MCR     p15, 0, r0, c1, c0, 0       ; write CP15 register 1

;==================================================================
; Cortex-A program flow prediction
;==================================================================

        MRC     p15, 0, r0, c1, c0, 0       ; read CP15 register 1 into r0
        ORR     r0, r0, #(0x1  <<11)        ; Enable all forms of branch prediction
        MCR     p15, 0, r0, c1, c0, 0       ; write CP15 register 1

;==================================================================

        BX lr

        END                                 ; mark the end of this file
; End of File InitCache.s
