;;-----------------------------------------------------------------------------
;; The confidential and proprietary information contained in this file may
;; only be used by a person authorised under and to the extent permitted
;; by a subsisting licensing agreement from ARM Limited.
;;
;;   (C) COPYRIGHT 1994-2007,2010-2012,2019 by Arm Limited (or its affiliates).
;;       ALL RIGHTS RESERVED
;;
;; This entire notice must be reproduced on all copies of this file
;; and copies of this file may only be made by a person if such person is
;; permitted to do so under the terms of a subsisting license agreement
;; from ARM Limited.
;;-----------------------------------------------------------------------------

        AREA VECT, CODE, READONLY
	ENTRY

;===================================================================
; Symbols needed from other modules
;===================================================================

        IMPORT  Reset_Handler           ; In Init.s

;===================================================================
;Constants used in this example
;
;===================================================================

angel_SWIreason_ReportException 	EQU 0x18
ADP_Stopped_ApplicationExit		EQU 0x20026

;===================================================================
;
; Exception Vector
;
; Note: LDR PC instructions are used here because branch (B) instructions
; could not simply be copied (the branch offsets would be wrong).  Also,
; a branch instruction might not reach if the ROM is at an address >32MB).
;===================================================================

        LDR	PC, =Reset_Handler
        LDR	PC, =Undefined_Handler
        LDR	PC, =SWI_Handler
        LDR	PC, =Prefetch_Handler
        LDR	PC, =Abort_Handler
        NOP                             ; Reserved vector
	LDR	PC, =IRQ_Handler
        LDR	PC, =FIQ_Handler


;===================================================================
; The following dummy handlers do not do anything useful in this example.
; They are set up here for completeness.
;===================================================================


Undefined_Handler
	B	Undefined_Handler ; infinite loop
	NOP
	NOP
	NOP
	NOP
	NOP

SWI_Handler
	CMP	R0, #angel_SWIreason_ReportException
	BNE	NOTEXITSWI
	LDR	R0, =ADP_Stopped_ApplicationExit
	CMP     R1,R0
	BNE     NOTEXITSWI
	LDR	PC, =Reset_Handler
NOTEXITSWI
	SUBS    PC, R14, #0     ; return
	NOP

Prefetch_Handler
	SUBS    PC, R14, #4     ; return
	NOP

Abort_Handler
	SUBS    PC, R14, #4     ; return
	NOP

IRQ_Handler
	SUBS    PC, R14, #4     ; return
	NOP

FIQ_Handler
	SUBS    PC, R14, #4     ; return
	NOP
	END

