/*
** Copyright (c) 2019 Arm Limited. All rights reserved.
*/

#include <stdio.h>
#include "memory_map.h"		// For definition of Serial_Base
#include "serial.h"

void simulation_exit()
{
    sendchar(4);
}

void sendchar(char ch)
{
    SERIAL_DATA = ch;  
    if (ch == '\n')                    
    {
        ch = '\r';                     
        sendchar(ch);
    }
}

// Special Performance markers - available for FastModel simulation only

void software_start()
{
    SOFTWARE_MARK = 1;
}

void software_stop()
{
    SOFTWARE_MARK = 0;
}

// Record (by printing to stdout) the cycles to this point, the boot code time
void record_boot() 
{
    SOFTWARE_MARK = 2;  // write to indicate startup code is complete 
}


// ReTargeting Code
// ================
#ifdef SERIAL

asm("  .global __use_no_semihosting\n");

struct __FILE {int handle;};
FILE __stdout;
FILE __stdin;
FILE __stderr;
    
int fputc(int ch, FILE *f)
{
    char tempch = ch;
    (void) sendchar(tempch);
    return ch;
}

void _ttywrch(int ch)
{
    char tempch = ch;
    (void) sendchar(tempch);
}

void _sys_exit(int return_code)
{
    while(1);
}

int clock()
{
    return(0);
}

#endif
 
