/*!
 *  \file   IrisSupportLibRevision.h
 *  \brief  Define IrisSupportLib revision.
 *  \date   Copyright ARM Limited 2015 All Rights Reserved.
 *
 */

#ifndef ARM_INCLUDE_IrisSupportLibRevision_h
#define ARM_INCLUDE_IrisSupportLibRevision_h


/// IRIS_SUPPORT_LIB_REVISION:
///
/// This revision has two purposes:
///
/// 1. Compile time checks for supported features.
///
/// 2. Making IrisSupportLib symbols unique in an executable (see IrisCommon.h).
//
/// Note: This is just the revision of IrisSupportLib. The Iris interfaces 
/// themselves have no version number or revision number. All supported interfaces
/// (functions, arguments, features) are discovered explicitly at runtime.
#ifndef IRIS_SUPPORT_LIB_REVISION
#define IRIS_SUPPORT_LIB_REVISION 0
#endif


/// IRIS_SUPPORT_LIB_FORK:
///
/// This is the name of the fork of IrisSupportLib.
/// The main fork has the name 'master'.
/// If you fork (copy) the IrisSupportLib code _and_ modify it
/// you should change the fork name to something unique
/// your domain/use case. This will allow to use the modified
/// fork and other forks (e.g. master) to be used in the same
/// executable without conflicts.
///
/// The fork name is used to make all IrisSupprtLib symbols
/// unique, see IrisCommon.h.
///
/// This must be a C identifier.
#ifndef IRIS_SUPPORT_LIB_FORK
#define IRIS_SUPPORT_LIB_FORK master
#endif


#endif // #ifndef ARM_INCLUDE_IrisSupportLibRevision_h
