/*!
 *  \file   IrisSystemInclude.h
 *  \brief  Includes system headers in a controlled manner
 *  \date   Copyright ARM Limited 2015 All Rights Reserved.
 *
 *  On Windows includes Windows.h with the right predefines
 *  on *nix includes unistd.h
 */

#ifndef ARM_INCLUDE_IrisSystemInclude_H
#define ARM_INCLUDE_IrisSystemInclude_H

#ifdef _WIN32
    #ifndef WIN32_LEAN_AND_MEAN
        #define WIN32_LEAN_AND_MEAN
        #define IRIS_WIN32_LEAN_AND_MEAN_DEFINED
    #endif
    #ifndef NOMINMAX
        #define NOMINMAX
        #define IRIS_NOMINMAX_DEFINED
    #endif

    #include <Windows.h>

    #ifdef IRIS_WIN32_LEAN_AND_MEAN_DEFINED
        #undef WIN32_LEAN_AND_MEAN
    #endif
    #ifdef IRIS_NOMINMAX_DEFINED
        #undef NOMINMAX
    #endif
#endif

#ifndef WIN32
    #include <unistd.h>
#endif

#endif
