/**
 * \file    Framework/include/ObjectLoaderAddress.h
 * \brief   ObjectLoader header file (interface specification)
 * \date    Copyright (c) 2000-2003 by ARM, Herzogenrath, Germany
 * \ingroup object_loader
 *
 * This file contains proprietary, unpublished source code
 * solely owned by ARM, Herzogenrath, Germany.
 * All rights reserved.
 */

#ifndef _ObjectLoaderAddress_h_
#define _ObjectLoaderAddress_h_ 1

#include <sg/IncludeMeFirst.h>
#include <cinttypes>

// address type used in the loader interfaces


// 2009-04-21: jo: ObjectLoaderAddress is now 64 bit, this is 99% source code compatible, no need to create redundant interfaces for 64 bit
typedef uint64_t ObjectLoaderAddress;
#define ObjectLoaderAddressBits 64
#define ObjectLoaderAddressMax UINT64_C(0xffffffffffffffff)
#define ObjectLoaderAddressFormat "%08" PRIX64


#endif

