/*
 * SCX: scx.h - SystemC eXport support: main header file.
 *
 * Copyright 2011-2016 ARM Limited.
 * All rights reserved.
 */

#ifndef ARM_SCX_H
#define ARM_SCX_H

/*!
 * \file    scx.h
 * \brief   Main header file.
 * \date    Copyright 2011-2016 ARM Limited. All rights reserved.
 *
 * SystemC eXport support main header file.
 */

/* Includes */

/* Version control related includes */
#include "scx_ver.h"

/* Exported Virtual Subsystem (EVS) related includes */
#include "scx_module_base.h"
#include "scx_evs_base.h"

/* Simulation configuration related includes */
#include "scx_simconfig.h"

/* Simulation control related includes */
#include "scx_simcontrol.h"

/* Simulation debug & plug-in support related includes */
#include "scx_simdebug.h"
#include "scx_iris.h"

/* Scheduling related includes */
#include "scx_sched.h"

/* Run-time reporting facilities related includes */
#include "scx_report.h"
#include "scx_ids.h"

/* Debug support and resource related includes */
#include "scx_debug_target_if.h"
#include "scx_debug_registers_if.h"
#include "scx_debug_memory_if.h"
#include "scx_debug_params_if.h"
#include "scx_debug_control_if.h"
#include "scx_debug_disass_if.h"

/* CADI support related includes */
#include "scx_cadi_target.h"

#endif  /* defined(ARM_SCX_H) */
