/* -*- c++ -*- */
/* vim: syntax=cpp
 */
/*!
 *  \file   Error.h
 *  \brief  Translation of errors returned from Framework Utility functions into strings.
 *  \author Paul Gotch
 *  \date   Copyright ARM Limited 2008 All Rights Reserved.
 *          Copyright ARM Limited 2015 All Rights Reserved.
 *
 *  This file is not part of a stable public API and it may
 *  change without notice.
 */

#ifndef INCLUDED_SG_ERROR_H
#define INCLUDED_SG_ERROR_H

#include "sg/PreInc.h"

#include <string>

#include "sg/PostInc.h"

namespace sg {

/*! Translate an error number returned from Framework Utility functions into a
 * human readable error message.
 *
 * \param   err Error number as returned from an Framework Utility function
 * \return  A string containing the error message, if the number can not be
 *          translated the null string may be returned.
 */
std::string TranslateError(int err);

}

#endif

/* eof Error.h */
