/* -*- c++ -*- */
/* vim: syntax=cpp
 */
/*!
 *  \file   FsCADIUtils.h
 *  \brief  Wrappers around CADI Functions to make them easier to use from C++
 *  \date   Copyright ARM Limited 2013-2016 All Rights Reserved.
 *
 *
 */

#ifndef INCLUDED_FSCADIUTILS_H
#define INCLUDED_FSCADIUTILS_H

#include <string>
#include <eslapi/CADI.h>
#include <eslapi/CADITypes.h>

namespace sg {

eslapi::CADIReturn_t CADIXfaceGetError_Wrapper(eslapi::CADI *cadi, std::string & msg);
eslapi::CADIReturn_t CADIParameterValue_fromString(eslapi::CADIParameterValue_t &, const std::string &);
eslapi::CADIReturn_t CADIParameterValue_toString(const eslapi::CADIParameterValue_t &, std::string &);
bool CADIParameterInfo_checkValue(const eslapi::CADIParameterInfo_t &, const eslapi::CADIParameterValue_t &, eslapi::CADIFactoryErrorMessage_t &);
bool CADIParameterInfo_checkString(const eslapi::CADIParameterInfo_t &, const std::string &, eslapi::CADIFactoryErrorMessage_t &);

/// An implementation of eslapi::CADICallbackObj::appliInput() that reads data from stdin.
void appliInput(uint32_t streamId, uint32_t count, uint32_t *actualCount, char *buffer);
}

#endif

/* eof FsCADIUtils.h */
