///
/// \file    SGComponentTrace_EventSourceN_inl.h
/// \brief   The inline definitions of EventSource0..EventSourceN
/// \date    Copyright 2016 ARM Limited. All rights reserved.
///
/// This is an automatically generated file please do not edit.
///
/// This is intended to be directly included into SGComponentTrace.h


class EventSource0 : public EventSourceBase {
public:
    EventSource0(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire() {
        EventSourceBase::fireEvent();
    }
};

template<typename T0>
class EventSource1 : public EventSourceBase {
public:
    EventSource1(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0) {
        EventSourceBase::fireEvent(p0);
    }
};

template<typename T0, typename T1>
class EventSource2 : public EventSourceBase {
public:
    EventSource2(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1) {
        EventSourceBase::fireEvent(p0, p1);
    }
};

template<typename T0, typename T1, typename T2>
class EventSource3 : public EventSourceBase {
public:
    EventSource3(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2) {
        EventSourceBase::fireEvent(p0, p1, p2);
    }
};

template<typename T0, typename T1, typename T2, typename T3>
class EventSource4 : public EventSourceBase {
public:
    EventSource4(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3) {
        EventSourceBase::fireEvent(p0, p1, p2, p3);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4>
class EventSource5 : public EventSourceBase {
public:
    EventSource5(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
class EventSource6 : public EventSourceBase {
public:
    EventSource6(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
class EventSource7 : public EventSourceBase {
public:
    EventSource7(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
class EventSource8 : public EventSourceBase {
public:
    EventSource8(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8>
class EventSource9 : public EventSourceBase {
public:
    EventSource9(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9>
class EventSource10 : public EventSourceBase {
public:
    EventSource10(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10>
class EventSource11 : public EventSourceBase {
public:
    EventSource11(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11>
class EventSource12 : public EventSourceBase {
public:
    EventSource12(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12>
class EventSource13 : public EventSourceBase {
public:
    EventSource13(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13>
class EventSource14 : public EventSourceBase {
public:
    EventSource14(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14>
class EventSource15 : public EventSourceBase {
public:
    EventSource15(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15>
class EventSource16 : public EventSourceBase {
public:
    EventSource16(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16>
class EventSource17 : public EventSourceBase {
public:
    EventSource17(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17>
class EventSource18 : public EventSourceBase {
public:
    EventSource18(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18>
class EventSource19 : public EventSourceBase {
public:
    EventSource19(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18, typename T19>
class EventSource20 : public EventSourceBase {
public:
    EventSource20(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18, T19 p19) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18, typename T19, typename T20>
class EventSource21 : public EventSourceBase {
public:
    EventSource21(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18, T19 p19, T20 p20) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18, typename T19, typename T20, typename T21>
class EventSource22 : public EventSourceBase {
public:
    EventSource22(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18, T19 p19, T20 p20, T21 p21) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20, p21);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18, typename T19, typename T20, typename T21, typename T22>
class EventSource23 : public EventSourceBase {
public:
    EventSource23(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18, T19 p19, T20 p20, T21 p21, T22 p22) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20, p21, p22);
    }
};

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9, typename T10, typename T11, typename T12, typename T13, typename T14, typename T15, typename T16, typename T17, typename T18, typename T19, typename T20, typename T21, typename T22, typename T23>
class EventSource24 : public EventSourceBase {
public:
    EventSource24(char const* name_="", char const* description_="")
        : EventSourceBase(name_, description_)
    {}

    inline void fire(T0 p0, T1 p1, T2 p2, T3 p3, T4 p4, T5 p5, T6 p6, T7 p7, T8 p8, T9 p9, T10 p10, T11 p11, T12 p12, T13 p13, T14 p14, T15 p15, T16 p16, T17 p17, T18 p18, T19 p19, T20 p20, T21 p21, T22 p22, T23 p23) {
        EventSourceBase::fireEvent(p0, p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20, p21, p22, p23);
    }
};
