
 /*!
  * \file    TimeAccumulator.h
  * \brief   An accumulator of time with a simple enough interface 
  * \date    Copyright 2015 ARM Limited. All rights reserved.
  *
  * TimeAccumulator is a utility class to allow clean and simple way
  * to accumulate time relative to durations of events or simply segments
  * of code. It counts the number of measurements as well as the total time.
*/

#ifndef TIMEACCUMULATOR_H
#define TIMEACCUMULATOR_H

namespace sg {

class TimeAccumulator
{
public:
    TimeAccumulator();
    void setStartTime();
    void updateTotal();

    double getTimeMS() const
    {
        return totTime*tick_period_ms;
    }

    uint32_t getCounter() const
    {
        return counter;
    }

private:
    double tick_period_ms;

    uint64_t startTime;
    uint64_t totTime;
    uint32_t counter;
};

}

#endif
