#!/usr/bin/env csh
#
# (C) COPYRIGHT 2017 ARM Limited. ALL RIGHTS RESERVED
#
# Settings for CM SystemC flow

if ( $?0 ) then
    echo $0 | \egrep 'setup.csh' > /dev/null
    if ( $status == 0 ) then
        echo ""
        echo "ERROR: the setup file must be SOURCED, NOT EXECUTED in a shell."
        echo "Try: source setup.csh"
        echo ""
        exit 1
    endif
endif

# LSOF is used so that the script can determine it's own location
if ( -x /usr/sbin/lsof ) then 
  set LSOF=/usr/sbin/lsof
else if ( -x /usr/bin/lsof ) then
  set LSOF=/usr/bin/lsof
else
  echo "ERROR could not find location of lsof command"
  exit 1
endif

set SCRIPTNAME=`$LSOF -w +p $$ | \grep -oE /.\*setup.csh | \tail -1`
pushd `\dirname $SCRIPTNAME`/.. > /dev/null
set INSTALLPATH=`\pwd`
popd > /dev/null

setenv CM_SYSC_HOME $INSTALLPATH

if( $?PATH ) then
  setenv PATH $INSTALLPATH/bin:$PATH
else
  setenv PATH $INSTALLPATH/bin
endif

echo "Arm Cycle Model SystemC setup completed."


