#!/usr/bin/env bash
#
# (C) COPYRIGHT 2017 ARM Limited. ALL RIGHTS RESERVED
#
# Settings for CM SystemC Flow

if [ "${0}" = "${BASH_SOURCE[0]}" ]; then
    echo ""
    echo "ERROR: the setup file must be SOURCED, NOT EXECUTED in a shell."
    echo "Try (for bash)  : source setup.sh"
    echo "Or (eg. for ksh):  . setup.sh"
    echo ""
    exit 1
fi

pushd `\dirname ${BASH_SOURCE[0]}`/.. > /dev/null
INSTALLPATH=`\pwd -L`
popd > /dev/null

export CM_SYSC_HOME=$INSTALLPATH

if [ -n "$PATH" ]; then
  export PATH=$INSTALLPATH/bin:$PATH
else
  export PATH=$INSTALLPATH/bin
fi

echo "Arm Cycle Model SystemC setup completed."


