//
// (C) COPYRIGHT 2017 ARM Limited. ALL RIGHTS RESERVED.
//

#ifndef ARM_MODELS_SLEVENTS_H
#define ARM_MODELS_SLEVENTS_H

/*
 * Event interfaces used by SignalLevel classes.
 */

namespace ARM
{
namespace Models
{
namespace SignalLevel
{

/*
 * Event that can be registered with a port as the first thing to
 * happen on a communication.
 */
class InputEvent
{
public:
    virtual ~InputEvent() {}

    /* Event to trigger at start of any input communication. */
    virtual void event() = 0;
};

}
}
}

#endif // ARM_MODELS_SLEVENTS_H
