//-------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited.
//
//            (C) COPYRIGHT 2015 ARM Limited.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited.
//
// This file forms part of the ARM standard for performance model
// memory transactions for SystemC TLM 2.0 and should not be
// modified.
//
// This standard is currently under review and is subject to change.
//-------------------------------------------------------------------

#ifndef ARM_TLM_PROTOCOL_H
#define ARM_TLM_PROTOCOL_H

namespace ARM
{
namespace TLM
{

/** AMBA protocols possible on ARM::TLM sockets. */
enum Protocol
{
    PROTOCOL_ACE          = 0,
    PROTOCOL_ACE_LITE     = 1,
    PROTOCOL_ACE_LITE_DVM = 2,
    PROTOCOL_AXI4         = 3,
    PROTOCOL_AXI4_LITE    = 4,
    PROTOCOL_CHI          = 5,
    /* Reserved           = 6 */
    PROTOCOL_CHIE         = 7,

    /*
     * Catch all value for when Protocol isn't used to distinguish one port
     * type from another.
     */
    PROTOCOL_OTHER        = 255
};

}
}

#endif // ARM_TLM_PROTOCOL_H
