//
// (C) COPYRIGHT 2017 ARM Limited. ALL RIGHTS RESERVED
//

#ifndef SCX_DUMMY_H
#define SCX_DUMMY_H

// Create dummy scx classes, defines and enum to remove dependencies on the
// FM runtime for DSM and SystemC Execution Test Benches

#define SCX_REPORT_FATAL(id,msg,...)  \
  fprintf(stderr,"Fatal: %s: ",id);   \
  fprintf(stderr,msg, ##__VA_ARGS__); \
  fprintf(stderr,"\n");
#define SCX_REPORT_ERROR(id,msg,...)  \
  fprintf(stderr,"Error: %s: ",id);   \
  fprintf(stderr,msg, ##__VA_ARGS__); \
  fprintf(stderr,"\n");
#define SCX_REPORT_WARNING(id,msg,...) \
  printf("Warning: %s: ",id);	       \
  printf(msg, ##__VA_ARGS__);	       \
  printf("\n");
#define SCX_REPORT_INFO(id,msg,...) \
  printf("Info: %s: ",id);	    \
  printf(msg, ##__VA_ARGS__);	    \
  printf("\n");

namespace scx
{
enum scx_debug_param_value_type
{
  SCX_DEBUG_PARAM_STRING,
  SCX_DEBUG_PARAM_INT,
  SCX_DEBUG_PARAM_BOOL
};
 
class scx_debug_target_if
{
 public:
  void add_param(const std::string& name,const std::string& description,scx_debug_param_value_type type,bool runtime=false,int min=0,int max=0,int value=0,const char* str ="")  {}
  void set_params_if(sc_module*) {}
};

class scx_cadi_target:public scx_debug_target_if
{
 public:
  scx_cadi_target(const char*, const char*, const char*){}
};

class scx_module_base
{
 public:
  scx_module_base(const char* name) {}
  void start_of_simulation() {}
  void end_of_simulation() {}
  void end_of_elaboration() {}
  void before_end_of_elaboration() {}
};
 
class scx_debug_params_if
{
};
}
#endif
