//
// (C) COPYRIGHT 2017 ARM Limited. ALL RIGHTS RESERVED.
//

#ifndef SCX_UNIVENT_TARMAC_H
#define SCX_UNIVENT_TARMAC_H

#include "univent_tarmac.h"

class scx_univent_tarmac: public scx_wrapper_feature
{
 public:
  scx_univent_tarmac(int num_cpus, CarbonObjectID * carbonModelHandle,scx::scx_debug_target_if& target):
    scx_wrapper_feature(num_cpus,carbonModelHandle,target)
  {
    setName("TARMAC");
    setDescription("Enable or disable TARMAC");
    addEnableParameter();
    addParameter("TARMAC_LOGFILE_NAME","","To set the TARMAC log file name");
#ifdef CM_SYSC_ENABLE_TARMAC
    enable();
#endif    
  }
   
#ifndef _WIN32
#ifndef CM_SYSC_NO_TARMAC
  virtual void enable()
  {
    std::string value;
    scx_wrapper_feature::enable();
    // set the LOGFILE name
    getParameter("TARMAC_LOGFILE_NAME",value);
    if (value != "")
      univent_tarmac_set_logfile(value.c_str());
    
    univent_tarmac_initialize(handle(),moduleName());
  }
  
  virtual void end_of_simulation()
  {
    univent_tarmac_terminate();
  }

  void set_time_unit(const char* env_var)
  {
    // if not set then use the SystemC time resolution to set the variable
    if (getenv(env_var) == NULL)
    {
      std::string tu = sc_get_time_resolution().to_string();
      size_t pos = tu.find(" ");
      setenv(env_var,tu.substr(pos+1).c_str(),1);
    }
  }
#endif
#endif
};

#endif
