//-------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited.
//
//            (C) COPYRIGHT 2015 ARM Limited.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited.
//
// Please refer to your legal agreement with ARM Limited to
// understand what you are licensed to do with this example code.
//-------------------------------------------------------------------

#ifndef ARM_MODELUTILS_ELFLOADER_H
#define ARM_MODELUTILS_ELFLOADER_H

#include <stdint.h>
#include "RAMBlock.h"

#include <functional>
typedef std::function <bool (uint64_t, uint8_t*, uint32_t)> f_dbg_write_t;

namespace ARM
{
namespace Models
{

bool ElfLoaderLoad (const char* filename, RAMBlock* ram_block, f_dbg_write_t *fptr=nullptr);
bool UBD_ElfLoaderLoad (const char* filename, f_dbg_write_t *fptr);
}
}

#endif // ARM_MODELUTILS_ELFLOADER_H
