//-------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited.
//
//            (C) COPYRIGHT 2015 ARM Limited.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited.
//
// Please refer to your legal agreement with ARM Limited to
// understand what you are licensed to do with this example code.
//-------------------------------------------------------------------

#ifndef ARM_MODELUTILS_RAMBLOCK_H
#define ARM_MODELUTILS_RAMBLOCK_H

#include <stdint.h>
#include <map>

#define RAM_BLOCK_PAGE_SIZE (4096)

namespace ARM
{
namespace Models
{
    class RAMBlock
    {
      std::map <uint64_t, unsigned char*> pages;
      unsigned char* get_page(uint64_t address);

    public:
      RAMBlock();
      ~RAMBlock();

      void read(uint64_t address, unsigned char* data, unsigned length);
      void write(uint64_t address, unsigned char* data, unsigned length);
    };
};
};

#endif // ARM_MODELUTILS_RAMBLOCK_H
