//-------------------------------------------------------------------
// The confidential and proprietary information contained in this file may
// only be used by a person authorised under and to the extent permitted
// by a subsisting licensing agreement from ARM Limited.
//
//            (C) COPYRIGHT 2015 ARM Limited.
//                ALL RIGHTS RESERVED
//
// This entire notice must be reproduced on all copies of this file
// and copies of this file may only be made by a person if such person is
// permitted to do so under the terms of a subsisting license agreement
// from ARM Limited.
//
// Please refer to your legal agreement with ARM Limited to
// understand what you are licensed to do with this example code.
//-------------------------------------------------------------------

#include <systemc>

#include "SimpleMem.h"
#include "SimpleMemImp.h"

namespace ARM
{
namespace Models
{

using namespace ModelSimpleMem;

SimpleMem::SimpleMem(sc_core::sc_module_name nm, SimpleMemConfig config) :
    sc_module(nm),
    clock("clock"),
    tSkt("tSkt", ARM::TLM::PROTOCOL_ACE, config.busWidthBits)
{
    module = new SimpleMemImp("imp", config);

    module->clock.bind(clock);
    tSkt.bind(module->tSkt);
    directTskt.bind(module->directTskt);
}

SimpleMem::~SimpleMem()
{
    delete module;
}

void SimpleMem::dump_memory() {
    module->dump_memory();
}

};
};
