#!/bin/sh
## this file must be sourced, not executed.
## it sets up your environment for using Arm Cycle Model Studio

echo $0 | egrep 'setup.sh' > /dev/null
if [ $? -eq 0 ]; then
	echo ""
	echo "ERROR: The Model Studio setup file must be SOURCED, NOT EXECUTED in a shell."
	echo "Try source setup.sh"
	exit 1
fi

pushd `dirname ${BASH_SOURCE[0]}`/.. > /dev/null
INSTALLPATH=`pwd -L`
popd > /dev/null

export CARBON_HOME=$INSTALLPATH

# do not unnecessarily extend variables with duplicates
if [[ ":$PATH:" != *":$CARBON_HOME/bin:"* ]]; then
    export PATH=$CARBON_HOME/bin:$PATH
fi

if [ -z "$LD_LIBRARY_PATH" ]; then
    export LD_LIBRARY_PATH=$CARBON_HOME/Linux64/lib
else
    if [[ ":$LD_LIBRARY_PATH:" != *":$CARBON_HOME/Linux64/lib:"* ]]; then
	export LD_LIBRARY_PATH=$CARBON_HOME/Linux64/lib:$LD_LIBRARY_PATH
    fi
fi


## using 'gcc/' here with the plan that if gcc versions is changed the shared/libcarbon5 and related files will still continue to work
if [[ ":$LD_LIBRARY_PATH:" != *":$CARBON_HOME/Linux64/lib/gcc/shared:"* ]]; then
    export LD_LIBRARY_PATH=$CARBON_HOME/Linux64/lib/gcc/shared:$LD_LIBRARY_PATH
fi


