#!/usr/bin/env bash
#
# (C) COPYRIGHT 2018 ARM Limited. ALL RIGHTS RESERVED
#
# Sources the individual package setup scripts
#

if [ "${0}" = "${BASH_SOURCE[0]}" ]; then
   echo ""
   echo "ERROR: The setup file must be SOURCED, NOT EXECUTED in a shell."
   echo "Try: source setup.sh"
   echo ""
   exit 1
fi

pushd `\dirname ${BASH_SOURCE[0]}` > /dev/null
SCRIPTDIR=`\pwd -L`
popd > /dev/null

ROOTDIR=`\dirname $SCRIPTDIR`
ABOVE_ROOTDIR=`\dirname $ROOTDIR`

# mainline is the latest version during development/eval
VERSIONED_DIR=$SCRIPTDIR/mainline

ls $VERSIONED_DIR >& /dev/null

if [ $? -ne 0 ]; then
    # List the directories in numerical order and grab the highest number
    VERSION_NUM=`\ls -v $SCRIPTDIR | \grep -E '^[0-9]+' | \tail -1`

    if [ -z "$VERSION_NUM" ]; then
        echo "ERROR: Could not find a valid directory in $SCRIPTDIR"
        exit 1
    else
        VERSIONED_DIR=$SCRIPTDIR/$VERSION_NUM
    fi
fi
source $VERSIONED_DIR/setup.sh
