#!/usr/bin/env bash
#
# (C) COPYRIGHT 2018 ARM Limited. ALL RIGHTS RESERVED
#
# Sources the individual package setup scripts
#

if [ "${0}" = "${BASH_SOURCE[0]}" ]; then
   echo ""
   echo "ERROR: The setup file must be SOURCED, NOT EXECUTED in a shell."
   echo "Try: source setup.sh"
   echo ""
   exit 1
fi

pushd `\dirname ${BASH_SOURCE[0]}` > /dev/null
SCRIPTDIR=`\pwd -L`
popd > /dev/null

ROOTDIR=`\dirname $SCRIPTDIR`
ABOVE_ROOTDIR=`\dirname $ROOTDIR`
 
if [ -n "$SYSTEMC_HOME" ]; then
  export SYSTEMC_HOME=${ROOTDIR} 
else
  export SYSTEMC_HOME=${ROOTDIR} 
fi
 
if [ -n "$SYSTEMC_INC" ]; then
  export SYSTEMC_INC=${SYSTEMC_HOME}/include 
else
  export SYSTEMC_INC=${SYSTEMC_HOME}/include 
fi
